unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Spin, StdCtrls, ExtCtrls, turtle, Math;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    FloatSpinEdit1: TFloatSpinEdit;
    FloatSpinEdit2: TFloatSpinEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    Turtle: TTurtle;
    procedure updateText;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Canvas.Clear;
  Image1.Canvas.Brush.Color:=$212121;
  Image1.Canvas.Pen.Color:=$212121;
  Image1.Canvas.FillRect(0,0,Image1.Width,Image1.Height);
  Image1.Canvas.Pen.Color:=$FF8800;
  Turtle:=TTurtle.Create(Image1.Canvas);
  updateText;
end;

procedure TForm1.updateText;
begin
  Label5.Caption:='Turtle looks to '+FloatToStr(Round(RadToDeg(Turtle.GetAktuellAngle)*1000)/1000)+' degrees';
  Label6.Caption:=('Turtles X Position is at '+FloatToStr(Round(100000*Turtle.GetAktuellXPos/Image1.Width)/1000)+' %'+sLineBreak+
                   'Turtles Y Position is at '+FloatToStr(Round(100000*Turtle.GetAktuellYPos/Image1.Height)/1000)+' %');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Turtle.TurnLeft(DegToRad(FloatSpinEdit2.Value));
  Turtle.MoveForward(Image1.Width*(FloatSpinEdit1.Value/100));
  updateText;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  max, i: Integer;
begin
  max:=SpinEdit1.Value-1;
  SpinEdit1.Value:=1;
  for i:=0 to max do
  begin
    Turtle.TurnRight(DegToRad(FloatSpinEdit2.Value));
    Turtle.DrawLine(Image1.Width*(FloatSpinEdit1.Value/100));
  end;
  updateText;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Image1.Canvas.Clear;
  Image1.Canvas.Brush.Color:=$212121;
  Image1.Canvas.Pen.Color:=$212121;
  Image1.Canvas.FillRect(0,0,Image1.Width,Image1.Height);
  Image1.Canvas.Pen.Color:=$FF8800;
  FloatSpinEdit1.Value:=0.00;
  FloatSpinEdit2.Value:=0.00;
  SpinEdit1.Value:=0;
  Turtle.SetSurface(Image1.Canvas);
  Turtle.MoveTo(Image1.Width/2, Image1.Height/2);
  Turtle.SetDirection(0);
  updateText;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  max, i: Integer;
begin
  max:=SpinEdit1.Value-1;
  SpinEdit1.Value:=1;
  for i:=0 to max do
  begin
    Turtle.TurnLeft(DegToRad(FloatSpinEdit2.Value));
    Turtle.DrawLine(Image1.Width*(FloatSpinEdit1.Value/100));
  end;
  updateText;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Turtle.Free;
end;

initialization
  {$I unit1.lrs}

end.

